#include <stdio.h>
#include <sys/types.h>
#include <string.h>
/* #include <strings.h> */
#include "option.h"
#include <math.h>

#define copystring(x,y) { x = (char *) malloc((unsigned int) strlen(y)+1); strcpy(x,y);}

void getParamDoWl(argc, argv, dirName, maxRunTimePtr, warmStartFlagPtr,
	numScriptIterPtr)
    int argc;
    char **argv;
    char **dirName;
    int *maxRunTimePtr;
    int *warmStartFlagPtr;
    int *numScriptIterPtr;
{
    int i;
    Option optionArray[4];

    void optionInit();
    void *malloc();

    optionInit(optionArray+0, OPT_STRING, "d", (char *) dirName,
	"directory to access");
    optionInit(optionArray+1, OPT_INT, "m", (char *) maxRunTimePtr,
	"maximum running time of program (seconds, int)");
    optionInit(optionArray+2, OPT_TRUE, "w", (char *) warmStartFlagPtr,
	"warm start (read all data before timing starts)");
    optionInit(optionArray+3, OPT_INT, "n", (char *) numScriptIterPtr,
	"number of times to run the scripts");
    
    /* set up default values */
    copystring(*dirName,".");
    (*maxRunTimePtr) = 3600;
    (*numScriptIterPtr) = 1;
    (*warmStartFlagPtr) = 0;

    Opt_Parse(argc, argv, optionArray, Opt_Number(optionArray), 0);

    /*
    if ( !(*warmStartFlagPtr) && (*numScriptIterPtr) > 1) {
	printf("error: trying to repeat the script more than once, but not warm starting\n");
	exit(1);
    }
    */
}
